!****************************************************************************
!****************************************************************************
! This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
!****************************************************************************
!****************************************************************************


!****************************************************************************
!****************************************************************************
! Write an YUV420 planar image in the texture memory of the dreamcast.
!
! (c)2001 Guillaume & Mathieu Legris.
!****************************************************************************
!****************************************************************************

.text


!****************************************************************************
! Class Dreamcast.
!****************************************************************************
!----------------------------------------------------------------------------
! .
!----------------------------------------------------------------------------
! struct ImageInfo {
!	void *address[4];
!	int32 stride[4];
!	int32 width;
!	int32 height;
!	int32 pixelFormat; // Don't care.
! };

! void copyImageYUV420ToTextureYUV422(ImageInfo *img, uint32 dstAddress,
!		uint32 dstStride);
	.align	5
.global _vu_dreamcast_copyImageYUV420ToTextureYUV422
_vu_dreamcast_copyImageYUV420ToTextureYUV422:
	mov.l		r8,@-r15
!	nop
	mov.l		r9,@-r15
!	nop
	mov.l		r10,@-r15
!	nop
	mov.l		r11,@-r15
!	nop
	mov.l		r12,@-r15
!	nop
	mov.l		r13,@-r15
!	nop
	mov.l		r14,@-r15

	mov		r5,r8 ! r8=destination address.
	mov.l		@(4*0,r4),r5 ! r5=Y address.
	mov		r6,r9 ! r9=destination stride.
	mov.l		@(4*1,r4),r6 ! r6=U address.
!	nop
	mov.l		@(4*2,r4),r7 ! r7=V address.
!	nop

	pref		@r5
!	nop
	pref		@r6
!	nop
	pref		@r7
!	nop

	mov.l		@(4*4,r4),r10 ! r10=Y stride.
!	nop
	mov.l		@(4*5,r4),r11 ! r11=U/V stride.
!	nop
	mov.l		@(4*8,r4),r12 ! r12=width.
!	nop
	mov.l		@(4*9,r4),r13 ! r13=height.


	! Destination address is texture memory.
	mova		.storeQueue,r0

	mov.l		@r0+,r1
	mov		#0xa4,r2
!	nop nop
	mov.l		r2,@r1 ! QACR0.
	add		#4,r1
	mov.l		r2,@r1 ! QACR1.

	sub		r12,r9
	mov.l		@r0+,r1 ! Store queue mask.
	sub		r12,r9 ! r9=destination stride-2*width.
	mov.l		@r0,r2 ! Store queue address.
	and		r1,r8
	or			r2,r8
!	nop

	sub		r12,r10 ! r10=Y stride-width.
!	nop
	shlr2		r12
!	nop
	shlr2		r12 ! r12=width/16.
!	nop

.loopY:
	mov		r12,r14

.loopX:
	mov.b		@(1,r5),r0 ! r0=0 0 0 Y1.
	mov		#7,r4
	mov.b		@r7+,r1 ! r1=0 0 0 V.
!	nop
	mov.b		@r5,r2 ! r2=0 0 0 Y0.
	add		#2,r5
	mov.b		@r6+,r3 ! r3=0 0 0 U.
.fillStoreQueue_loop:
	shll8		r0 ! r0=0 0 Y1 0.
!	nop
	extu.b	r1,r1
!	nop
	or			r1,r0 ! r0=0 0 Y1 V.
	mov.b		@r7+,r1 ! r1=0 0 0 V.

	shll8		r0 ! r0=0 Y1 V 0.
!	nop
	extu.b	r2,r2
!	nop
	or			r2,r0 ! r0=0 Y1 V Y0.
	mov.b		@r5,r2 ! r2=0 0 0 Y0.

	shll8		r0 ! r0=Y1 V Y0 0.
!	nop
	extu.b	r3,r3
!	nop
	or			r3,r0 ! r0=Y1 V Y0 U.
	mov.b		@r6+,r3 ! r3=0 0 0 U.

	dt			r4
	mov.l		r0,@r8
	add		#4,r8
	mov.b		@(1,r5),r0 ! r0=0 0 0 Y1.
	bf/s		.fillStoreQueue_loop
	 add		#2,r5

	pref		@r5
	shll8		r0 ! r0=0 0 Y1 0.
	pref		@r6
	extu.b	r1,r1
	pref		@r7
	or			r1,r0 ! r0=0 0 Y1 V.

!	nop
	shll8		r0 ! r0=0 Y1 V 0.
!	nop
	extu.b	r2,r2
!	nop
	or			r2,r0 ! r0=0 Y1 V Y0.

!	nop
	shll8		r0 ! r0=Y1 V Y0 0.
!	nop
	extu.b	r3,r3
!	nop
	or			r3,r0 ! r0=Y1 V Y0 U.

	mov.l		r0,@r8
	dt			r14
	pref		@r8
	bf/s		.loopX
	 add		#4,r8

	add		r10,r5
	mov		r12,r0
	pref		@r5
	shll2		r0
!	nop
	shll		r0 ! r0=width/2.
!	nop
	sub		r0,r6
!	nop
	sub		r0,r7

	mov		r13,r0
	tst		#1,r0
	bt/s		.oddLine
	 add		r9,r8
	add		r11,r6
!	nop
	add		r11,r7
!	nop
.oddLine:

	dt			r13
	pref		@r7
	bf/s		.loopY
	 pref		@r6

	mov.l		@r15+,r14
!	nop
	mov.l		@r15+,r13
!	nop
	mov.l		@r15+,r12
!	nop
	mov.l		@r15+,r11
!	nop
	mov.l		@r15+,r10
!	nop
	mov.l		@r15+,r9
!	nop
	rts
	 mov.l	@r15+,r8

	.align	5
.storeQueue:
	.long		0xff000038
	.long		0x03ffffe0
	.long		0xe0000000
!****************************************************************************
